chrome.webRequest.onBeforeSendHeaders.addListener((details) => {
    if (details.url.startsWith('https://httpbin.org/redirect-to')) {
        const refererHeader = details.requestHeaders.find(header => header.name.toLowerCase() === 'aaa');
        if (refererHeader) {
            refererHeader.value = 'foo';
        } else {
            details.requestHeaders.push({ name: 'aaa', value: 'foo' });
        }
        return { requestHeaders: details.requestHeaders };
    }
}, {
    urls: [ '<all_urls>' ],
    types: [ 'xmlhttprequest' ]
}, [ 'blocking', 'requestHeaders' ]);

setTimeout(() => {
    fetch('https://httpbin.org/redirect-to?url=https://httpbin.org/headers')
    .then(response => response.json())
    .then(data => {
        console.log(data);
    });
}, 1000);