(async () => {
    const rs = await chrome.declarativeNetRequest.getDynamicRules();
    for (const r of rs) {
        const { id } = r;
        await chrome.declarativeNetRequest.updateDynamicRules({ removeRuleIds: [ id ] });
    }
    chrome.declarativeNetRequest.updateDynamicRules({
        addRules: [
            {
                id: 1,
                condition: {
                    urlFilter: 'redirect-to',
                    resourceTypes: [ 'xmlhttprequest' ]
                },
                action: {
                    type: 'modifyHeaders',
                    requestHeaders: [
                        {
                            header: 'bbb',
                            operation: 'set',
                            value: 'foo'
                        }
                    ]
                }
            }
        ]
    });


    setTimeout(() => {
        fetch('https://httpbin.org/redirect-to?url=https://httpbin.org/headers')
        .then(response => response.json())
        .then(data => {
            console.log(data);
        });
    }, 1000);
})();